#include <reg552.h>																					//Tento program je schopn prijimat a vysielat plne duplexne pomocou prerusenia ...
#include <stdio.h>																					//V pripade vysokorychlostnych prenosov je vhodne task SERIAL zaradit do 3 urovne priority.
#include <stdlib.h>
#include <string.h>
#include <rtx51.h>

#define	SPEEDx																							//Pri urovni priority 3 to v simulacii spadne po niekolkych sekundach ...
#define	WaitForEver	0xFF
#define	Preamble	'^'

#define	CLOCK			0
#define	SERIAL		1
#define	DHCP			2

#define	MSG_232		0
#define	MSG_TIME	1
#define	MSG_DHCP	2
																														//Note: Simultaneous waiting on several semaphores or mailboxes is not allowed.
#define	TKN_CRC		8																					//Waiting for a mailbox combined with waiting for a semaphore is not supported. These two wait types are mutually exclusive.
																														//ol(* ! ?PR?_CHECK_CRC?RS232NET)	-	Overlay. Semaphorer a Mailboxes sa nemozu kombinovat v taskoch !!!
#ifdef SIMUL
sbit	LED_TXD	=	P1^0;
sbit	LED_RXD	=	P1^1;
#endif

enum Protocol {ICMP=3, IPv4=50, IP6v4=51, TCP=6, UDP=17};
#define	Type	IPv4

#define	Message_IP_Request	"IP_Request"
#define	Message_IP_Accept		"IP_Accept"
#define	Message_IP_Ack			"IP_Acknowledge"

#define PrefixAdr	0xC0A80100																//192.168.1.0
#define	SrcIPAddr	0xC0A80101																//192.168.1.1
#define	DstIPAddr	0xC0A8017B																//192.168.1.123
#define	BcsIPAddr	0xC0A801FF																//192.168.1.255
#define	NetIPMask	0xFFFFFF00																//255.255.255.0

#define	MaxSizeOfPacketData	(0xFF-12)												//Velkost datovej polozky packet-u max. 255-12=243
#define	SizeOfPacketData		16															//Velkost datovej polozky packet-u.
#define	Pattern	'\0'

typedef xdata struct
{
 unsigned char Pre;
 long int Dst,Src;
 unsigned char Typ;																					//TCP=6, UDP=17, ICMP=3, IPv4=50, IPv6=51 ...
 unsigned char Length;
 unsigned char Data[SizeOfPacketData];
 unsigned char Crc;
}
Packet51;

#define NumMemBlocks	2																			//Definujem [n] pouzitych pamatovych blokov ...
#define	SizeMemBlock	sizeof(Packet51)											//Velkost pouzivaneho packetu v strukture ...
#define	SizeMemPool		NumMemBlocks*(2+SizeMemBlock)					//(Header+sizeof(Packet51)*n)

xdata Packet51 Packet = {Preamble,DstIPAddr,SrcIPAddr,Type,SizeOfPacketData,{NULL},NULL};
xdata Packet51 *MessageToSend,*ReceivedMessage,*ReceivedBuffer;	//Ukazovatel na strukturu Packet51, je to len adresa kde musi byt rezervovany blok pamati
#ifdef SIMUL
xdata Packet51 pkt51={Preamble,SrcIPAddr,DstIPAddr,Type,SizeOfPacketData,"0123456789ABCDEF",NULL};	//Potrebne len pre simulaciu v debugger.ini ...
xdata unsigned char MemoryPool[SizeMemPool] _at_ 0x0000;		//MemoryPool je niekedy lepsie definovat na pevnej adrese ale uVision robi problemy pri simulacii ...
xdata unsigned char *RcvMsg,SERIN,SEROUT;										//Potrebne len pre simulaciu v debugger.ini ...
#else
xdata unsigned char MemoryPool[SizeMemPool];
#endif

unsigned char Check_CRC(unsigned char *Block)								//Ak volam rutinu z viacerych taskov preto musi byt reentrantna, inac nemusi byt rrntrantna...
{
 unsigned char i,tmp=0x00;
 for(i=0x00; i<(SizeMemBlock-1); i++) tmp+=Block[i];				//Scitam vsetky polozky packetu. Pocitam 8-bitove CRC ako u INTEL-HEX formatu
 tmp=~tmp+1;
 return(tmp);
}

void Clock(void) _task_ CLOCK _priority_ 0
{
 signed char RtxCompletion;
 unsigned char Hod,Min,Sek,*ptr;
 #ifdef SIMUL
 RcvMsg=(unsigned char xdata*)&pkt51;												//Potrebne len pre simulaciu v debugger.ini ...
 pkt51.Crc=Check_CRC((unsigned char xdata*)&pkt51);					//Potrebne len pre simulaciu v debugger.ini ...
 #endif
 if(sscanf(__TIME__,"%02bd:%02bd:%02bd",&Hod,&Min,&Sek)!=0x03) Hod=Min=Sek=0x00;
 while(1)
  {
	 if(++Sek==60) {Sek=0; if(++Min==60) {Min=0; if(++Hod==24) {Hod=0;}}}
	 switch(RtxCompletion=os_wait(K_IVL,100,NULL))
	  {
		 case	TMO_EVENT	:	Packet.Pre=Preamble;
											Packet.Src=SrcIPAddr;																											//Packet.Src=Convert(192,168,1,1);
											Packet.Dst=DstIPAddr;																											//Packet.Dst=Convert(192,168,1,123);
											Packet.Typ=Type;
											Packet.Length=SizeMemBlock;
											sprintf(Packet.Data,"%02bd:%02bd:%02bd\r\n",Hod,Min,Sek);
											Packet.Crc=Check_CRC((unsigned char xdata*)&Packet);
											ptr=memcpy(MessageToSend,&Packet,SizeMemBlock);														//Skopirujem obsah bloku do pomocnej premennej
											#ifdef SIMUL																															//Potrebne len pre simulaciu v debugger.ini ...
											pkt51.Pre=Preamble;
											pkt51.Src=DstIPAddr;																											//pkt51.Dst=Convert(192,168,1,1);
											pkt51.Dst=SrcIPAddr;																											//pkt51.Src=Convert(192,168,1,123);
											pkt51.Typ=Type;
											pkt51.Length=SizeMemBlock;
											sprintf(pkt51.Data,"%02bd:%02bd:%02bd\r\n",Hod,Min,Sek);
											pkt51.Crc=Check_CRC((unsigned char xdata*)&pkt51);
											#endif
											RtxCompletion=os_send_message(MSG_232,(unsigned int)MessageToSend,1);			//Posielam tu istu adresu objektu Packet51 cez message v trvani do 10ms...
											//RtxCompletion=os_free_block(SizeMemBlock,MessageToSend);
											break;
		}
	}
}

extern void Init_Serial(void);

#ifdef SPEED
#pragma REGISTERBANK (1)																//Pre najvyssiu prioritu treba dat _priority_ 3
void Serial(void) _task_ SERIAL _priority_ 3
#else
#pragma REGISTERBANK (0)																//Pre najvyssiu prioritu treba dat _priority_ 3
void Serial(void) _task_ SERIAL _priority_ 0
#endif
{
 signed char RtxCompletion;
 unsigned char *oBuffer,*iBuffer,*ptr;
 #ifdef SPEED
 idata unsigned char Znak,crc,in,out;										//Aby sa nespustilo nevyziadane vysielanie
 #else
 unsigned char Znak,crc,in,out;													//Aby sa nespustilo nevyziadane vysielanie
 #endif
 #ifdef SIMUL
 LED_TXD=LED_RXD=0;
 #endif
 RtxCompletion=os_set_slice(15360);
 RtxCompletion=os_create_pool(SizeMemBlock,MemoryPool,SizeMemPool); 	//Vytvorim MemoryPool v pamati XRAM pre datove struktury ...
 if(RtxCompletion!=OK) while(1);																			//Ak MemoryPool nie je tak sa radsej zacyklim ....
 if((MessageToSend=os_get_block(SizeMemBlock))!=NULL);
 if((ReceivedBuffer=os_get_block(SizeMemBlock))!=NULL); 
 RtxCompletion=os_create_task(CLOCK);
 RtxCompletion=os_create_task(DHCP);
 RtxCompletion=os_attach_interrupt(4);																//Pripojim sa na prerusenie 23h t.j. RS232 co je seriove rozhranie ...
 Init_Serial();
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_SIG+K_INT+K_MBX+MSG_232,WaitForEver,(unsigned int xdata*)&ReceivedMessage))
	  {
		 case	SIG_EVENT	:	switch((unsigned char)((ReceivedBuffer->Dst)&(~NetIPMask)))					//Prijimam IP adresu a maskujem ju ...
											 {
											  case	0x00	:	break;																							//Je to adresa siete a neda sa na nic pouzit ...
												case	0x01	:																											//Je to moja adresa a je to pre mna ...
												case	0xFF	:	F0=1;	break;																				//Je to broadcast adresa a je to pre vsetkych ...
												default			:	break;																							//Nie je to pre mna ... je to nejaka cielova adresa ...
											 }
											break;
		 case	MSG_EVENT	:	oBuffer=(unsigned char xdata*)ReceivedMessage;											//Nastavim adresu vysielacieho buffera ktory je dynamicky alokovany
											out=0x00;
											#ifdef SIMUL
											LED_TXD=1;																													//Pri vysielani rozsvietim LED
											S0BUF=SEROUT=oBuffer[out];
											#else
											S0BUF=oBuffer[out];
											#endif
											break;
		 case	INT_EVENT	:	//#include <transmit.c>
											if(TI)																															//Nastalo vysielanie dat ...
											 {
												TI=0;
												switch(++out)
												 {
													default							:	
																									#ifdef SIMUL
																									S0BUF=SEROUT=oBuffer[out];
																									#else
																									S0BUF=oBuffer[out];
																									#endif
																									break;
													case	SizeMemBlock	: 
																									#ifdef SIMUL
																									LED_TXD=0;
																									#endif
																									break;
												 }
											 }											
											//#include <receive.c>
											if(RI)																															//Nastal prijem dat ....
											 {
												RI=0; 
												#ifdef SIMUL
												LED_RXD=1;																												//Pri prijimani rozsvietim LED
												#endif
												switch(Znak=S0BUF)
												 {
													case	Preamble	:	iBuffer=(unsigned char xdata*)ReceivedBuffer;	//Nastavim adresu prijimacieho buffera ktory je dynamicky alokovany
																						ptr=memset(iBuffer,Pattern,SizeMemBlock);			//Inicializujem - vymazem jeho obsah
																						in=crc=0x00;
													default					:	
																						#ifdef SIMUL
																						iBuffer[in++]=SERIN=Znak;
																						#else
																						iBuffer[in++]=Znak;
																						#endif
																						if(in==SizeMemBlock)
																						 {
																							in=0x00;
																							crc=~crc+1;																	//Spocitam dvojkovy doplnok ...
																							#ifdef SIMUL
																							LED_RXD=0;
																							#endif
																							if(ReceivedBuffer->Crc==crc)								//Vykonam kontrolu neporusenosti prijateho Packet-u
																							 {
																								RtxCompletion=os_clear_signal(SERIAL);		//Ak som nieco nestihol tak to zrusim, CRC mi zahodi chybu ...
																								RtxCompletion=os_send_signal(SERIAL);			//Prijal som Packet a dam o tom vediet ...
																							 }
																							}
																							 else
																							  {
																								 crc+=Znak;																//Pocitam CRC prijateho packet-u takto, aby som nepotreboval reentrant-nu rutinu !!!
																								}
																							break;
												  }
											  }
											break;
		}
	}
}

#pragma REGISTERBANK (0)

void Dhcp(void) _task_ DHCP _priority_ 0
{
 signed char RtxCompletion;
 unsigned int MessageDHCP;
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_MBX+MSG_DHCP,WaitForEver,&MessageDHCP))
	  {
		 case	NOT_OK		:	RtxCompletion=os_delete_task(DHCP);																	//Nieco nie je v poriadku a tak vykonam restart tasku ...
											RtxCompletion=os_create_task(DHCP);
											break;
		 case	TMO_EVENT	:	break;
		 case	SIG_EVENT	:	break;
		}
	}
}

void main(void)
{
 os_start_system(SERIAL);
}